Index: main/pbx.c
===================================================================
--- main/pbx.c	(revision 281496)
+++ main/pbx.c	(working copy)
@@ -4329,6 +4329,7 @@
 						error = 1;
 					} else {
 						pbx_builtin_raise_exception(c, "ERROR");
+						c->priority++;
 						continue;
 					}
 				}
@@ -4370,6 +4371,7 @@
 				set_ext_pri(c, "i", 1);
 			} else if (ast_exists_extension(c, c->context, "e", 1, c->cid.cid_num)) {
 				pbx_builtin_raise_exception(c, "INVALID");
+				c->priority++;
 			} else {
 				ast_log(LOG_WARNING, "Channel '%s' sent into invalid extension '%s' in context '%s', but no invalid handler\n",
 					c->name, c->exten, c->context);
@@ -4416,6 +4418,7 @@
 						set_ext_pri(c, "i", 1);
 					} else if (ast_exists_extension(c, c->context, "e", 1, c->cid.cid_num)) {
 						pbx_builtin_raise_exception(c, "INVALID");
+						c->priority++;
 					} else {
 						ast_log(LOG_WARNING, "Invalid extension '%s', but no rule 'i' in context '%s'\n", dst_exten, c->context);
 						found = 1; /* XXX disable message */
@@ -4428,6 +4431,7 @@
 						set_ext_pri(c, "t", 1);
 					} else if (ast_exists_extension(c, c->context, "e", 1, c->cid.cid_num)) {
 						pbx_builtin_raise_exception(c, "RESPONSETIMEOUT");
+						c->priority++;
 					} else {
 						ast_log(LOG_WARNING, "Timeout, but no rule 't' in context '%s'\n", c->context);
 						found = 1; /* XXX disable message */
